<?php
require_once SSC_APPLICATION_PATH . '/services/SeoScore/Factor/Abstract/Bool.php';

class Ssc_Service_SeoScore_Factor_WordsFirst
    extends Ssc_Service_SeoScore_Factor_Abstract_Bool
{
    protected $_wordCount = 100;

    public function init()
    {
        parent::init();

        $this->_label = "Content contains primary keyword in the first {$this->_wordCount} words.";
    }

    public function analyze($service)
    {
        $content = $service->getAnalyzeData('post_text');

        if ($service->analyzeContentWords('word_count') > $this->_wordCount) {
            $positions = $service->analyzeContentWords('word_postitions');
            $content = substr($content, 0, $positions[$this->_wordCount][1]);
        }

        return $this->setValue((bool)$service->keywordInText($content));
    }
}
