<?php
require_once SSC_APPLICATION_PATH . '/services/SeoScore/Helper/Abstract/Base.php';

abstract class Ssc_Service_SeoScore_Helper_Abstract_AnalyzeMetaTag
    extends Ssc_Service_SeoScore_Helper_Abstract_Base
{
    protected $_result;
    protected $_pattern;

    const PATTERN_TAG = '~<\s*{$name}\b[^>]*>(.*?)<\s*/\s*{$name}\s*>~isu';
    const PATTERN_META = '~<\s*meta\b[^>]*\bname\s*=\s*[\'"]{$name}[\'"][^>]*\bcontent=[\'"](.*?)[\'">]~isu';

    public function direct($service, $key=NULL)
    {
        if (is_null($this->_result)) {
            $content = $service->getAnalyzeData('html');
            $keyword = $service->getAnalyzeData('primary');

            if (!preg_match($this->_pattern, $content, $matches)
            ) {
                return FALSE;
            }

            $text = $service->htmlToText($matches[1]);
            $keywordMatch = $this->_keywordMatch($service, $text, $keyword);

            $this->_result = array(
                'keyword_match' => $keywordMatch,
                'text' => $text,
            );
        }

        if (!is_null($key)) {
            return isset($this->_result[$key])? $this->_result[$key] : NULL;
        }

        return $this->_result;
    }

    // For overiding in child classes
    protected function _keywordMatch($service, $text, $keyword)
    {
        return $service->keywordInText($text, $keyword, TRUE);
    }
}