<?php
require_once SSC_APPLICATION_PATH . '/services/SeoScore/Helper/Abstract/Base.php';

class Ssc_Service_SeoScore_Helper_AnalyzeLinks
    extends Ssc_Service_SeoScore_Helper_Abstract_Base
{
    protected $_result;

    public function direct($service, $key)
    {
        if (is_null($this->_result)) {
            $content = $service->getAnalyzeData('post_html');
            $keyword = $service->getAnalyzeData('primary');

            $internal = FALSE;
            $external = FALSE;
            if (preg_match_all('~<\s*a\s[^>]*\bhref=["\'](.*?)["\'>][^>]*>(.*?)<\s*/\s*a\s*>~isu',
                $content, $matches)
            ) {
                $domain = @parse_url($service->getAnalyzeData('url'), PHP_URL_HOST);

                foreach ($matches[2] as $i=>$match) {
                    $match = $service->htmlToText($match);
                    if ($service->keywordInText($match, $keyword)) {
                        $linkDomain = @parse_url(htmlspecialchars_decode($matches[1][$i]), PHP_URL_HOST);
                        if (FALSE == $linkDomain) {
                            continue; //malformed URL
                        }

                        if ('' == $linkDomain || $domain == $linkDomain) {
                            $internal = TRUE;
                        } else {
                            $external = TRUE;
                        }

                        if ($internal && $external) {
                            break;
                        }
                    }
                }
            }

            $this->_result = array(
                'internal' => $internal,
                'external' => $external,
            );
        }

        if (!is_null($key)) {
            return isset($this->_result[$key])? $this->_result[$key] : NULL;
        }

        return $this->_result;
    }
}
